/**
 * This work is provided under the terms of the CREATIVE COMMONS PUBLIC
 * LICENSE. This work is protected by copyright and/or other applicable
 * law. Any use of the work other than as authorized under this license
 * or copyright law is prohibited.
 *
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 *
 * © 2015 Voiceworks B.V. info@voiceworks.com
 *
 */

define('com.voiceworks/ox-messenger/conversation/models/messagecontainer', [
    'com.voiceworks/ox-messenger/conversation/models/messagecollection'
], function (MessageCollection) {
    'use strict';

    /**
     * Message Container
     */
    var MessageContainer = Backbone.Model.extend({

        defaults: {
            conversation: null,
            messages: null,
            senderUser: null,
            fileDesc: null
        },

        // TODO first param is data, not options (results in a duplicate allocation)
        initialize: function (options) {
            MessageContainer.__super__.initialize.apply(this, arguments);

            this.conversation = options ? options.conversation : null;
            this.messages = new MessageCollection();
            this.senderUser = options ? options.senderUser : null;
        },

        /**
         *
         * @param message
         * @param {boolean} prepend Only for history messages to preserve the order of
         * msgs with the same timestamp.
         */
        addMessage: function (message, prepend) {
            if (prepend) {
                this.messages.add(message, {at: 0});
            } else {
                this.messages.add(message);
            }
            this.messages.sort();
        },

        comparator: function () {
            return this.messages.first().get('timestamp');
        }

    });

    return MessageContainer;
});
