/**
 * This work is provided under the terms of the CREATIVE COMMONS PUBLIC
 * LICENSE. This work is protected by copyright and/or other applicable
 * law. Any use of the work other than as authorized under this license
 * or copyright law is prohibited.
 *
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 *
 * © 2015 Voiceworks B.V. info@voiceworks.com
 *
 */

define('com.voiceworks/ox-messenger/conversation/models/messagecontainercollection', [
    'com.voiceworks/ox-messenger/conversation/models/messagecontainer'
], function (MessageContainerModel) {
    'use strict';

    /**
     * Message Container Collection
     */
    var MessageContainerCollection = Backbone.Collection.extend({
        model: MessageContainerModel,

        comparator: function (container) {
            return container.messages.first().get('timestamp');
        },

        add: function (model) {
            var ret = MessageContainerCollection.__super__.add.apply(this, arguments);

            // Bind the messages collection events to the parent conversation collection.
            if (model) {
                this.listenTo(model.messages, 'add', _.debounce(function (model, collection, options) {
                    this.trigger('add', model, collection, options);
                }, 300));
            }

            return ret;
        }
    });

    return MessageContainerCollection;
});
