/**
 * This work is provided under the terms of the CREATIVE COMMONS PUBLIC
 * LICENSE. This work is protected by copyright and/or other applicable
 * law. Any use of the work other than as authorized under this license
 * or copyright law is prohibited.
 *
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 *
 * © 2015 Voiceworks B.V. info@voiceworks.com
 *
 */

// @TODO: remove

define('com.voiceworks/ox-messenger/core/apicall', [
	'com.voiceworks/ox-messenger/core/session'
],
function (Session) {
    'use strict';
    /**
     * ApiCall Model - allows calls to oxvwbackend api
     */
    var ApiCall = Backbone.Model.extend({

        initialize: function () {
            this.apiKey               = null;
            this.sessionId            = null;
			this.apiUrl               = null;
			this.localDev             = false;
        },

        setParameters: function (apiLocation, apiKey, sessionId) {

            this.apiKey               = apiKey;
            this.sessionId            = sessionId;
			this.apiUrl               = apiLocation;

			if (this.localDev) {
				this.apiKey               = '1234567890';
				this.sessionId            = '1';
				this.apiUrl               = 'http://127.0.0.1/sites/oxvwbackend/public/index.php';
			}
        },

		get: function (method, params, callbackFn) {
			var head   = document.head;
			var script = document.createElement('script');

			var reqUri = '?callback=' + callbackFn + '&method=' + method;
			reqUri    += '&params[apiKey]=' + this.apiKey;
			reqUri    += '&params[applicationSessionId]=' + this.sessionId;

			for (var namedParam in params) {
				reqUri += '&params[' + namedParam + ']=' + params[namedParam];
			}

			script.setAttribute('src', this.apiUrl + reqUri);
			head.appendChild(script);
			head.removeChild(script);
		}
    });


    return new ApiCall();
});