/**
 * This work is provided under the terms of the CREATIVE COMMONS PUBLIC
 * LICENSE. This work is protected by copyright and/or other applicable
 * law. Any use of the work other than as authorized under this license
 * or copyright law is prohibited.
 *
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 *
 * © 2015 Voiceworks B.V. info@voiceworks.com
 *
 */

define('com.voiceworks/ox-messenger/core/contactsearch', [
    'com.voiceworks/ox-messenger/core/session',
    'com.voiceworks/ox-messenger/util',
    'gettext!com.voiceworks/ox-messenger',
    'settings!com.voiceworks/ox-messenger',
], function (Session, Util, gt, Settings) {

    var ContactSearch = {
        byPhonenumber: function (query) {
            var that = this,
                list = [],
                resultLimit = parseInt(Settings.get('phoneSearchResultLimit'), 10),
                pattern = new RegExp(Util.escapeRegExp(query), 'gi'),
                resultCount = 0;

            _.each(Session.user.contacts, function (contact) {
                _.each(Util.contactPhoneFields, function (field) {
                    if (!contact[field] || (!contact[field].match(pattern) && !contact.display_name.match(pattern))) {
                        return;
                    }

                    resultCount++;
                    if (resultCount > resultLimit) {
                        return;
                    }

                    list.push({
                        id: contact[field],
                        name: contact.display_name,
                        number: contact[field],
                        numberType: Util.contactPhoneFieldMapping[field]
                    });
                });
                if (resultCount >= resultLimit) {
                    return;
                }
            });

            return list;
        }
    };

    return ContactSearch;

});