﻿/**
 * This work is provided under the terms of the CREATIVE COMMONS PUBLIC
 * LICENSE. This work is protected by copyright and/or other applicable
 * law. Any use of the work other than as authorized under this license
 * or copyright law is prohibited.
 *
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 *
 * © 2015 Voiceworks B.V. info@voiceworks.com
 *
 */

define('com.voiceworks/ox-messenger/core/logger', [
], function () {
    'use strict';

    var LogMessageModel = Backbone.Model.extend({
        defaults: {
            log: 'log',
            module: '',
            category: '',
            label: '',
            content: ''
        }
    });

    var LoggerModel = Backbone.Model.extend({

        initialize: function () {
            this.logMessages = new Backbone.Collection();
        },

        write: function (level, category, label, content) {
            console.info(content);
            var logMessage = new LogMessageModel({
                level: level,
                category: category,
                label: label,
                content: content,
                timestamp: new Date().getTime()
            });
            this.logMessages.add(logMessage);
        },

        dump: function () {
            
        }
    });

    return LoggerModel;
});