/**
 * This work is provided under the terms of the CREATIVE COMMONS PUBLIC
 * LICENSE. This work is protected by copyright and/or other applicable
 * law. Any use of the work other than as authorized under this license
 * or copyright law is prohibited.
 *
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 *
 * © 2015 Voiceworks B.V. info@voiceworks.com
 *
 */

 define('com.voiceworks/ox-messenger/file/views/dropzone', [
     'io.ox/core/dropzone',
     'com.voiceworks/ox-messenger/aggregator',
     'com.voiceworks/ox-messenger/core/views/disposable',
     'com.voiceworks/ox-messenger/file/main',
     'gettext!com.voiceworks/ox-messenger',
     'less!com.voiceworks/ox-messenger/conversation/style'
 ], function (dropzone, Aggregator, DisposableView, FileController, gt) {
     'use strict';

     /**
      * DOM Drop Zone
      */
    var DropzoneView = DisposableView.extend({
        className: 'messenger--dropzone',

        initialize: function (options) {
            this.caption = options.caption ? options.caption : gt('Drop files here to upload');
        },

        render: function () {
            var zone = new dropzone.Inplace({
                    caption: this.caption
                });

            zone.on({
                'drop': function (files) {
                    FileController.uploadFiles(
                        files,
                        function(fileDesc){
                            Aggregator.trigger('file:uploadstart', fileDesc);
                        },
                        function(fileDesc){
                            Aggregator.trigger('file:uploadend', fileDesc);
                        });
                }
            });

            this.$el = zone.render().$el.addClass('abs');

            return this;
        }
    });

    return DropzoneView;
});
