/**
 * This work is provided under the terms of the CREATIVE COMMONS PUBLIC
 * LICENSE. This work is protected by copyright and/or other applicable
 * law. Any use of the work other than as authorized under this license
 * or copyright law is prohibited.
 *
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 *
 * © 2015 Voiceworks B.V. info@voiceworks.com
 *
 */

define('com.voiceworks/ox-messenger/roster/models/group', [
    'com.voiceworks/ox-messenger/roster/models/usercollection'
], function (RosterUserCollection) {
    'use strict';

    /**
     * Roster Group Model
     */
    var RosterGroupModel = Backbone.Model.extend({

        defaults: {
            name: '',
            index: 100,
            query: '',
            toggled: false
        },

        initialize: function () {
            this.users = new RosterUserCollection();
        },

        search: function () {

            var query = this.get('query'),
                results,
                searchUsers = new RosterUserCollection();

            if (!_.isEmpty(query)) {
                var pattern = new RegExp(query, 'gi');

                results = this.users.filter(function (user) {
                    return user.getDisplayName() && user.getDisplayName().match(pattern);
                });

                searchUsers.add(results);
            }
            return searchUsers;
        }
    });

    return RosterGroupModel;
});