/**
 * This work is provided under the terms of the CREATIVE COMMONS PUBLIC
 * LICENSE. This work is protected by copyright and/or other applicable
 * law. Any use of the work other than as authorized under this license
 * or copyright law is prohibited.
 *
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 *
 * © 2015 Voiceworks B.V. info@voiceworks.com
 *
 */

define('com.voiceworks/ox-messenger/roster/models/usercollection', [
    'com.voiceworks/ox-messenger/core/user'
], function (UserModel) {
    'use strict';

    /**
     * Roster User Collection
     */
    var RosterUserCollection = Backbone.Collection.extend({

        model: UserModel,

        comparator: function (a, b) {
            var connectedA = a.get('status') === 'offline' ? 0 : 1,
                connectedB = b.get('status') === 'offline' ? 0 : 1;

            if (this.sortFirst) {
                if (a === this.sortFirst) {
                    return -1;
                }

                if (b === this.sortFirst) {
                    return 1;
                }
            }

            if (connectedA === connectedB) {
                return a.getDisplayName() < b.getDisplayName() ? -1 : 1;
            }

            return connectedA < connectedB ? 1 : -1;
        },

        getOnlineUsers: function () {
            return this.models.filter(function (model) {
                return !model.isOffline();
            });
        }
    });

    return RosterUserCollection;
});
