define([
    'com.voiceworks/ox-messenger/mediator',
    'com.voiceworks/ox-messenger/conversation/models/conversationcollection',
    'com.voiceworks/ox-messenger/conversation/models/conversation',
    'com.voiceworks/ox-messenger/conversation/views/conversationlist'
], function (Mediator, ConversationCollection, Conversation, ConversationListView) {

    describe('ConversationList', function () {

        beforeEach(function () {
            console.log('--- mediator ----', Mediator);

            Mediator.init();


            var conversationList = new ConversationCollection();

            this.view = new ConversationListView({ collection: conversationList });
            console.log(this.view);
            $('body', document).append(
                this.view.render().$el
            );

            var conversation1 = new Conversation({ user: null });
            console.info('conv1', conversation1);

            this.view.setCollection(conversationList);

            conversationList.add(conversation1);
        });

        afterEach(function () {
            this.view.remove();
        });

        it('should contain a list container', function () {
            console.info('listEl', this.view.$el);

            expect(this.view.$el.length).to.be.equal(1);
        });

        it('the list should contain a conversation', function () {
            expect(this.view.$el.children().length).to.be.equal(1);
        });

        it('the conversation should contain a title', function () {
            expect(this.view.$el.find('li').first()).to.be.equal(1);
        });

        // it('when receiving an archive collection, a conversation list should be created', function () {
        //     var data = [{'timestamp':'2015-02-03T12:43:28.000Z','from':'wouter.leenards@test.redhosting.nl','to':'tjitte.test@test.redhosting.nl/oxmessenger','body':'Message 1'},{'timestamp':'2015-02-03T12:43:29.000Z','from':'wouter.leenards@test.redhosting.nl','to':'tjitte.test@test.redhosting.nl/oxmessenger','body':'Message 2'},{'timestamp':'2015-02-03T12:43:30.000Z','from':'wouter.leenards@test.redhosting.nl','to':'tjitte.test@test.redhosting.nl/oxmessenger','body':'Message 3'}];
        //     var spy = sinon.spy(Mediator, 'messageCollectionHandler');

        //     Mediator.messageCollectionHandler(data);

        //     expect(spy.calledOnce).to.be(true);
        // });


        it('should start a new conversation', function () {
            Mediator.messageCollectionHandler(this.messageCollectionData);
        });

    });

});
