define([
    'com.voiceworks/ox-messenger/roster/models/group',
    'com.voiceworks/ox-messenger/core/user',
    'com.voiceworks/ox-messenger/roster/models/usercollection'
], function (RosterGroupModel, RosterUserModel, RosterUserCollection) {

    describe('RosterGroupModel ', function () {
        var rosterGroup,
            user1 = {
                id: 1,
                contact: {
                    display_name: 'user1'
                }
            },
            user2 = {
                id: 2,
                contact: {
                    display_name: 'user2'
                }
            },
            users = [user1, user2]
            ;

        beforeEach(function () {
            rosterGroup = new RosterGroupModel();
        });

        it('should have a users collection', function () {
            expect(rosterGroup.users).to.be.instanceOf(RosterUserCollection);
        });

        it('should find the correct user on search', function () {
            rosterGroup.users.add(users);
            rosterGroup.set('query', 'user1');
            var foundUsers = rosterGroup.search();
            expect(foundUsers.models.length).to.be.greaterThan(0);
            expect(foundUsers).to.be.instanceOf(RosterUserCollection);
//            expect(found.at(0).get('contact')).to.equal(user1.contact.display_name);
        });
    });

});
