define(['io.ox/core/extensions',
        'com.voiceworks/ox-messenger/aggregator',
        'com.voiceworks/ox-messenger/roster/views/search'],
    function (ext, aggregator, RosterSearchView) {

    describe('SearchView ', function () {

        it('should provide an extension point for the search', function (done) {
            ext.point('io.ox/messenger/roster/search').extend({
                id: 'roster-search-test',
                draw: function () {
                    done();
                }
            });
            new RosterSearchView().render();
        });


        it('should trigger search events', function () {
            var spy = sinon.spy(),
                searchField;

            // let's spy what happens
            aggregator.on('roster:search', spy);

            // render the view and make sure nothing happens yet
            searchField = new RosterSearchView().render().$('#roster-search');
            expect(spy.called, 'No search event should be sent unneccessarily').to.be.false;

            // let's enter text and fake keyup events
            searchField.val('Hay');
            searchField.keyup();
            expect(spy.calledOnce, 'Search is started on every keyUp event').to.be.true;

            searchField.val('Haystack');
            searchField.keyup();
            expect(spy.calledTwice, 'Search is started on every keyUp event').to.be.true;
        });

    });

});
